// CRC examples -- Chapter 9 header

// Copyright 2024 Philip Koopman
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//    http://www.apache.org/licenses/LICENSE-2.0
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <inttypes.h>
#include <assert.h>
#include <stdio.h>

// Useful constants to avoid magic numbers in code
extern const uint32_t bitsPerByte;
 
// Publicly visible procedures to compute CRCs 
uint16_t CRC16_LeftA(uint16_t cw16[], uint32_t cwSize,
       uint32_t initialSeed, uint32_t finalXOR);
uint16_t CRC16_LeftB(uint16_t cw16[], uint32_t cwSize,
       uint32_t initialSeed, uint32_t finalXOR);
uint16_t CRC16_LeftC(uint16_t cw16[], uint32_t cwSize,
       uint32_t initialSeed, uint32_t finalXOR);
uint16_t CRC16_RightD(uint16_t cw16[], uint32_t cwSize,
       uint32_t initialSeed, uint32_t finalXOR);
uint16_t CRC16_RightE(uint16_t cw16[], uint32_t cwSize,
       uint32_t initialSeed, uint32_t finalXOR);
uint32_t CRC_RGeneric(uint8_t dw[], uint32_t dwSize, 
                 uint32_t modulus, uint32_t initialSeed,
                 uint32_t finalXOR);
uint32_t CRC_RGenericT(uint8_t dw[], uint32_t dwSize, 
                uint32_t modulus, uint32_t initialSeed, 
                uint32_t finalXOR);
uint32_t CRC_LGeneric(uint8_t dw[], uint32_t dwSize, 
               uint32_t modulus, uint32_t initialSeed, 
               uint32_t finalXOR, uint32_t bits);
uint32_t CRC_LGenericT(uint8_t dw[], uint32_t dwSize, 
               uint32_t modulus, uint32_t initialSeed, 
               uint32_t finalXOR, uint32_t bits);
uint32_t CRC_RGenericT32sub8(uint8_t dw[],
               uint32_t dwSize, uint32_t modulus, 
               uint32_t initialSeed, uint32_t finalXOR);
uint64_t CRC_RGeneric64(uint8_t dw[], uint32_t dwSize, 
                 uint64_t modulus, uint64_t initialSeed,
                 uint64_t finalXOR);
uint64_t CRC_RGenericT64sub8(uint8_t dw[],
               uint32_t dwSize, uint64_t modulus, 
               uint64_t initialSeed, uint64_t finalXOR);

uint32_t crcLookupPrintR(uint32_t modulus);
